.386
.model	flat, stdcall
option	casemap :none

include		windows.inc
include		user32.inc
include		kernel32.inc
include		comctl32.inc	;windows common controls

includelib	user32.lib
includelib	kernel32.lib
includelib	comctl32.lib	;windows common controls

DlgProc		PROTO	:DWORD,:DWORD,:DWORD,:DWORD

.const
IDD_MAIN	equ	1000
IDB_TIME	equ	1001
IDC_EDIT1002 equ	1002
.data
FmtSysTime db "Last Modified: %d\%d\%d @ %d:%d:%d", 0 

.data?
hInstance	dd	?
lpLastAccess 	db 128 dup (?)
folderpath 	db 128 dup (?)
	    ftime FILETIME <>
	    stime SYSTEMTIME <>

.code
start:
	invoke	GetModuleHandle, NULL
	mov	hInstance, eax
	invoke	InitCommonControls
	invoke	DialogBoxParam, hInstance, IDD_MAIN, 0, offset DlgProc, 0
	invoke	ExitProcess, eax
	

DlgProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	mov	eax,uMsg
	
	.if	eax == WM_INITDIALOG
		invoke	LoadIcon,hInstance,200
		invoke	SendMessage, hWin, WM_SETICON, 1, eax
	.elseif eax == WM_COMMAND
		mov	eax,wParam
		.if	eax == IDB_TIME
		invoke SendDlgItemMessage,hWin,IDC_EDIT1002,WM_GETTEXT,sizeof folderpath,addr folderpath
		invoke CreateFile, addr folderpath, GENERIC_READ, FILE_SHARE_READ, NULL,\
                        OPEN_EXISTING, FILE_ATTRIBUTE_DIRECTORY, NULL
                  mov esi, eax
                  invoke GetFileTime,esi,0,addr ftime,0
                  Invoke CloseHandle, esi
                  invoke FileTimeToSystemTime,addr ftime,addr stime

					mov edi,offset stime 
					assume edi: ptr SYSTEMTIME 
					movzx eax, [edi]. wYear 
					movzx ebx, [edi]. wMonth 
					movzx ecx, [edi]. wDay 
					movzx edx, [edi]. wHour 
					movzx esi, [edi]. wMinute 
					movzx edi, [edi]. wSecond 
					assume edi: nothing 
				invoke wsprintf, addr lpLastAccess, addr FmtSysTime,\
										 ecx, ebx, eax, edx, esi, edi

			invoke SendDlgItemMessage,hWin,IDC_EDIT1002,WM_SETTEXT,0,addr lpLastAccess
		.endif
	.elseif	eax == WM_CLOSE
		invoke	EndDialog, hWin, 0
	.endif

	xor	eax,eax
	ret
DlgProc endp

end start